Summary:        An advanced IRC bouncer
Name:           znc
Version:        0.052
Release:        4%{?dist}.cru
License:        GPLv2
Group:          System Environment/Daemons
URL:            http://znc.sf.net/
Vendor:         Veit Wahlich <cru@zodia.de>
Packager:       Veit Wahlich <cru@zodia.de>
Source0:        http://dl.sourceforge.net/sourceforge/znc/znc-%{version}.tar.gz
Source1:        znc-crox-svn-admin.cpp
Source2:        znc-crox-svn-antiidle.cpp
Source3:        znc-crox-svn-fish.cpp
Source4:        znc-crox-svn-statupdate.cpp
Source5:        znc-cnu-log.cpp
Patch0:         znc-0.052-add_denysetvhost2.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  which gcc-c++ 
%{!?_without_ssl:BuildRequires: openssl-devel >= 0.9.8}
%{!?_without_sasl:BuildRequires: cyrus-sasl-devel}
%{!?_without_perl:BuildRequires: perl}

%description
ZNC is an IRC bounce with many advanced features like detaching,
multiple users, per channel playback buffer, SSL, IPv6, transparent
DCC bouncing, Perl and C++ module support to name a few.

Available rebuild switches:
  --without ssl    Build without support for SSL encryption.
  --without sasl   Build without Cyrus SASL authentication module.
  --without perl   Build without Perl scripting module.
  --without ipv6   Build without IPv6 connection support.
  --with debug     Build debugging binaries.

%package admin
Summary:        znc admin global module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description admin
A global module for the znc IRC bouncer.
Allows you to add/remove/edit users and settings on the fly via IRC
messages.

%package imapauth
Summary:        znc imapauth global module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description imapauth
A global module for the znc IRC bouncer.
Allows users to authenticate via IMAP.

%{!?_without_perl:%package modperl}
%{!?_without_perl:Summary:        znc modperl global module}
%{!?_without_perl:Group:          System Environment/Daemons}
%{!?_without_perl:Requires:       %{name} = %{version}-%{release}}

%{!?_without_perl:%description modperl}
%{!?_without_perl:A global module for the znc IRC bouncer.}
%{!?_without_perl:Loads perl scripts as ZNC modules.}

%package partyline
Summary:        znc partyline global module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description partyline
A global module for the znc IRC bouncer.
Allows ZNC users to join internal channels and query other ZNC users
on the same ZNC.

%{!?_without_sasl:%package saslauth}
%{!?_without_sasl:Summary:        znc saslauth global module}
%{!?_without_sasl:Group:          System Environment/Daemons}
%{!?_without_sasl:Requires:       %{name} = %{version}-%{release}}

%{!?_without_sasl:%description saslauth}
%{!?_without_sasl:A global module for the znc IRC bouncer.}
%{!?_without_sasl:Allow users to authenticate via SASL.}

%package webadmin
Summary:        znc webadmin global module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description webadmin
A global module for the znc IRC bouncer.
Allows you to add/remove/edit users and settings on the fly via a web
browser.

%package antiidle
Summary:        znc antiidle user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description antiidle
A user module for the znc IRC bouncer.
Hides your idle time.

%package autoattach
Summary:        znc autoattach user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description autoattach
A user module for the znc IRC bouncer.
Reattaches you to channels on activity.

%package autoop
Summary:        znc autoop user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description autoop
A user module for the znc IRC bouncer.
Auto op the good guys.

%{!?_without_ssl:%package away}
%{!?_without_ssl:Summary:        znc away user module}
%{!?_without_ssl:Group:          System Environment/Daemons}
%{!?_without_ssl:Requires:       %{name} = %{version}-%{release}}

%{!?_without_ssl:%description away}
%{!?_without_ssl:A user module for the znc IRC bouncer.}
%{!?_without_ssl:Stores messages while away, also auto away.}

%package awaynick
Summary:        znc awaynick user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description awaynick
A user module for the znc IRC bouncer.
Change your nick while you are away.

%package chansaver
Summary:        znc chansaver user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description chansaver
A user module for the znc IRC bouncer.
Keeping config up to date when user joins and parts.

%{!?_without_ssl:%package crypt}
%{!?_without_ssl:Summary:        znc crypt user module}
%{!?_without_ssl:Group:          System Environment/Daemons}
%{!?_without_ssl:Requires:       %{name} = %{version}-%{release}}

%{!?_without_ssl:%description crypt}
%{!?_without_ssl:A user module for the znc IRC bouncer.}
%{!?_without_ssl:Encryption for channel/private messages.}

%package email
Summary:        znc email user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description email
A user module for the znc IRC bouncer.
Monitors email activity on local disk /var/mail/user.

%{!?_without_ssl:%package fish}
%{!?_without_ssl:Summary:        znc fish user module}
%{!?_without_ssl:Group:          System Environment/Daemons}
%{!?_without_ssl:Requires:       %{name} = %{version}-%{release}}

%{!?_without_ssl:%description fish}
%{!?_without_ssl:A user module for the znc IRC bouncer.}
%{!?_without_ssl:Adds the ability to encrypt all your outgoing messages with the FiSH}
%{!?_without_ssl:blowfish block-cipher. This way you can do the decryption/encryption}
%{!?_without_ssl:on the bouncer instead of your IRC client.}

%package kickrejoin
Summary:        znc kickrejoin user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description kickrejoin
A user module for the znc IRC bouncer.
An Autorejoin module. Allows you to rejoin a channel (after a delay)
when kicked.

%package log
Summary:        znc log user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description log
A user module for the znc IRC bouncer.
Log conversations to file.

%package nickserv
Summary:        znc nickserv user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description nickserv
A user module for the znc IRC bouncer.
Auths you with NickServ.

%package perform
Summary:        znc perform user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description perform
A user module for the znc IRC bouncer.
Performs commands on connect.

%package raw
Summary:        znc raw user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description raw
A user module for the znc IRC bouncer.
View all of the raw traffic.

%{!?_without_ssl:%package savebuff}
%{!?_without_ssl:Summary:        znc savebuff user module}
%{!?_without_ssl:Group:          System Environment/Daemons}
%{!?_without_ssl:Requires:       %{name} = %{version}-%{release}}

%{!?_without_ssl:%description savebuff}
%{!?_without_ssl:A user module for the znc IRC bouncer.}
%{!?_without_ssl:Saves your channel buffers into an encrypted file so they can survive}
%{!?_without_ssl:restarts and reboots.}

%{!?_without_ssl:%package schat}
%{!?_without_ssl:Summary:        znc schat user module}
%{!?_without_ssl:Group:          System Environment/Daemons}
%{!?_without_ssl:Requires:       %{name} = %{version}-%{release}}

%{!?_without_ssl:%description schat}
%{!?_without_ssl:A user module for the znc IRC bouncer.}
%{!?_without_ssl:SSL (encrypted) DCC chats.}

%package shell
Summary:        znc shell user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description shell
A user module for the znc IRC bouncer.
Have your unix shell in a query window right inside of your IRC
client.

%package statupdate
Summary:        znc statupdate user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description statupdate
A user module for the znc IRC bouncer.
StatUpdate writes users online status into a text file.

%package stickychan
Summary:        znc stickychan user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description stickychan
A user module for the znc IRC bouncer.
Keeps you sticked to specific channels.

%package watch
Summary:        znc watch user module
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}

%description watch
A user module for the znc IRC bouncer.
Monitor activity for specific text patterns from specific users and
have the text sent to a special query window.

%package devel
Summary:        Development files needed to compile znc modules
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description devel
All includes and program files you need to compile your own znc
modules.

%prep
%setup -q
%patch0 -p1 -b .add_denysetvhost
%__cp %{SOURCE1} modules/admin.cpp
%__cp %{SOURCE2} modules/antiidle.cpp
%__cp %{SOURCE3} modules/fish.cpp
%__cp %{SOURCE4} modules/statupdate.cpp
%__cp %{SOURCE5} modules/log.cpp
%__mv modules/sample.cpp .
%__perl -pi.add_release -e 's|(?<="ZNC \%1\.3f)|-%{release}|' znc.cpp

%build
%configure \
	--with-module-prefix=%{_libdir}/znc \
	%{?_without_ssl:--disable-openssl} \
	%{!?_without_sasl:--enable-sasl} \
	%{?_without_perl:--disable-perl} \
	%{!?_without_ipv6:--enable-ipv6} \
	%{?_with_debug:--enable-debug} 
%__make %{?_smp_mflags}

%install
%__rm -Rf "%{buildroot}"
%__make install DESTDIR="%{buildroot}"

%clean
%__rm -Rf "%{buildroot}"

%files
%defattr(-,root,root)
%doc AUTHORS LICENSE README znc.conf
%{_bindir}/znc

%files admin
%defattr(-,root,root)
%{_libdir}/znc/admin.so

%files imapauth
%defattr(-,root,root)
%{_libdir}/znc/imapauth.so

%{!?_without_perl:%files modperl}
%{!?_without_perl:%defattr(-,root,root)}
%{!?_without_perl:%{_libdir}/znc/modperl.pm}
%{!?_without_perl:%{_libdir}/znc/modperl.so}

%files partyline
%defattr(-,root,root)
%{_libdir}/znc/partyline.so

%{!?_without_sasl:%files saslauth}
%{!?_without_sasl:%defattr(-,root,root)}
%{!?_without_sasl:%{_libdir}/znc/saslauth.so}

%files webadmin
%defattr(-,root,root)
%{_libdir}/znc/webadmin.so
%{_libdir}/znc/webadmin/skins/*

%files antiidle
%defattr(-,root,root)
%{_libdir}/znc/antiidle.so

%files autoattach
%defattr(-,root,root)
%{_libdir}/znc/autoattach.so

%files autoop
%defattr(-,root,root)
%{_libdir}/znc/autoop.so

%{!?_without_ssl:%files away}
%{!?_without_ssl:%defattr(-,root,root)}
%{!?_without_ssl:%{_libdir}/znc/away.so}

%files awaynick
%defattr(-,root,root)
%{_libdir}/znc/awaynick.so

%files chansaver
%defattr(-,root,root)
%{_libdir}/znc/chansaver.so

%{!?_without_ssl:%files crypt}
%{!?_without_ssl:%defattr(-,root,root)}
%{!?_without_ssl:%{_libdir}/znc/crypt.so}

%files email
%defattr(-,root,root)
%{_libdir}/znc/email.so

%{!?_without_ssl:%files fish}
%{!?_without_ssl:%defattr(-,root,root)}
%{!?_without_ssl:%{_libdir}/znc/fish.so}

%files kickrejoin
%defattr(-,root,root)
%{_libdir}/znc/kickrejoin.so

%files log
%defattr(-,root,root)
%{_libdir}/znc/log.so

%files nickserv
%defattr(-,root,root)
%{_libdir}/znc/nickserv.so

%files perform
%defattr(-,root,root)
%{_libdir}/znc/perform.so

%files raw
%defattr(-,root,root)
%{_libdir}/znc/raw.so

%{!?_without_ssl:%files savebuff}
%{!?_without_ssl:%defattr(-,root,root)}
%{!?_without_ssl:%{_libdir}/znc/savebuff.so}

%{!?_without_ssl:%files schat}
%{!?_without_ssl:%defattr(-,root,root)}
%{!?_without_ssl:%{_libdir}/znc/schat.so}

%files shell
%defattr(-,root,root)
%{_libdir}/znc/shell.so

%files statupdate
%defattr(-,root,root)
%{_libdir}/znc/statupdate.so

%files stickychan
%defattr(-,root,root)
%{_libdir}/znc/stickychan.so

%files watch
%defattr(-,root,root)
%{_libdir}/znc/watch.so

%files devel
%defattr(-,root,root)
%doc sample.cpp
%{_bindir}/znc-buildmod
%{_bindir}/znc-config
%{_includedir}/znc/*
